var data_log;
var hPunkte = []; // ein Array der Helligkeitspunkte

// wo fängt Beschriftung und Graph an?
var StartpunktX = 40;
var StartpunktY = 70;

// wie wird der Graph in der Höhe skaliert
var factor = 2.3;

function preload() {
  // einlesen der Werte in die Variable "data_log"
  // hier korrekten, relativen Pfad eingeben!
  data_log = loadTable("daten/data_log.csv");
}

function setup() {
  createCanvas(960, 520);
  background(240);
  textSize(16);
  noStroke();

  // Überschrift
  fill(0);
  text("Tabellenwerte als Graph, live-Werte", StartpunktX, StartpunktY - 30);

  // wieviele Zeilen enthält die Datei "data_log.csv"
  var anzahl = data_log.getRowCount();
  // console.log("Anzahl:" + anzahl);

  textAlign(RIGHT);
  var Datensaetze = "Datensätze: " + anzahl;
  text(Datensaetze, width - 20, StartpunktY - 30);

  // liest alle Helligkeitswerte in das Array ein
  for (var i = 0; i < anzahl; i++) {
    hPunkte[i] = data_log.getNum(i, 3);
  }

  // Breite der Rechtecke abhängig von Anzahl der Einträge bei "data_log.csv"
  // "130" durch Ausprobieren ermittelt!
  var b = (width - 130) / anzahl;
  var a = b + b / 10; // Abstand der Rechtecke ebenfalls proportional

  for (var i = 0; i < anzahl; i++) {
    // je nach Helligkeitswert werden die Rechtecke unterschiedlich eingefärbt
    if (hPunkte[i] <= 200) {
      fill(182, 8, 0);
    } else if (hPunkte[i] > 200 && hPunkte[i] <= 400) {
      fill(232, 44, 0);
    } else if (hPunkte[i] > 400 && hPunkte[i] <= 600) {
      fill(226, 117, 0);
    } else if (hPunkte[i] > 600 && hPunkte[i] <= 800) {
      fill(227, 206, 00);
    } else {
      fill(236, 233, 0);
    }

    // die Rechtecke werden gezeichnet, Höhe wird durch den "factor", damit der Graph nicht zu hoch wird
    rect(StartpunktX + a * i, StartpunktY, b, hPunkte[i] / factor);
  }

  textSize(12);

  // waagrechte Maßlinien und vertikale Beschriftung
  for (var i = 0; i < 11; i++) {
    // die yPos der Linien bzw. der Texte
    var yPos = StartpunktY + (100 / factor) * i;
    // die Linien
    stroke(150);
    line(StartpunktX - 5, yPos, width - 20, yPos);
    // die Beschriftung vertikal
    noStroke();
    fill(120);
    textAlign(RIGHT);
    var Ausgabe = 100 * i; // z.B. "0", "100" usw.
    text(Ausgabe, StartpunktX - 7, yPos + 4);
  }

  // Beschriftung der Skala, horizontal
  textAlign(CENTER);

  // die horizontale Beschriftung passt sich an:
  // wenn wenige Einträge vorhanden sind, wird jeder Balken einzeln beschriftet
  // sonst nur jeder 10. Eintrag
  if (anzahl <= 45) {
    var i_Sprung = 1;
  } else {
    i_Sprung = 10;
  }

  for (var i = 0; i < anzahl; i = i + i_Sprung) {
    text(i, StartpunktX + b / 2 + i * a, StartpunktY - 5);
  }
}
